SOCKATMARK(3)

NAME
sockatmark - determine whether socket is at out-of-band mark

SYNOPSIS
#include <sys/socket.h>

int sockatmark(int fd);

DESCRIPTION
sockatmark() returns a value indicating whether or not the socket referred to by the file descriptor fd is at the out-of-band mark. If the socket is at the mark, then 1 is returned; if the socket is not at the mark, 0 is returned. This function does not remove the out-of-band mark.

RETURN VALUE
A successful call to sockatmark() returns 1 if the socket is at the out-of-band mark, or 0 if it is not. On error, -1 is returned and errno is set to indicate the error.

ERRORS

EBADF
    fd is not a valid file descriptor.

EINVAL
    fd is not a file descriptor to which sockatmark() can be applied.

NOTES
If sockatmark() returns 1, then the out-of-band data can be read using the MSG_OOB flag of recv(2). Out-of-band data is only supported on some stream socket protocols. sockatmark() can safely be called from a handler for the SIGURG signal. sockatmark() is implemented using the SIOCATMARK ioctl() operation.

CONFORMING TO
POSIX.1-2001

VERSIONS
sockatmark() was added to glibc in version 2.2.4.

BUGS
Prior to glibc 2.4, sockatmark() did not work.

EXAMPLE
The following code can be used after receipt of a SIGURG signal to read (and discard) all data up to the mark, and then read the byte of data at the mark:
    char buf[BUF_LEN];
    char oobdata;
    int atmark, s;
    for (;;) {
        atmark = sockatmark(fd);
        if (atmark == -1) {
            perror("sockatmark");
            break;
        }

        if (atmark)
            break;

        s = read(fd, buf, BUF_LEN) <= 0);
        if (s == -1)
            perror("read");
        if (s <= 0)
            break;
    }

    if (atmark == 1) {
        if (recv(fd, &oobdata, 1, MSG_OOB) == -1) {
            perror("recv");
            ...
        }
    }

SEE ALSO
fcntl(2), recv(2), send(2), tcp(7)